{$IFNDEF Win32}
{$C MOVEABLE,DEMANDLOAD,DISCARDABLE}
{$ENDIF}

{*********************************************************}
{*                   Tracing.PAS 1.0                     *}
{*     Copyright 1997 (c) informatique MICRO-CONTROLE    *}
{*                 All rights reserved.                  *}
{*********************************************************}

unit Tracing;

interface

uses
  {$IFDEF Win32} Windows, {$ELSE} WinTypes, WinProcs, {$ENDIF}
  SysUtils, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, Buttons, ExtCtrls, StdCtrls, IMCWinTr;


type
  TTrace = class(TForm)
    Panel1: TPanel;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    ScrollBox1: TScrollBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    MainMenu1: TMainMenu;
    test1: TMenuItem;
    start1: TMenuItem;
    Restart1: TMenuItem;
    Stop1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Test2: TMenuItem;
    Line1: TMenuItem;
    Buffer1: TMenuItem;
    Commit1: TMenuItem;
    N2: TMenuItem;
    Conter1: TMenuItem;
    TestError: TMenuItem;
    TestLevel1: TMenuItem;
    TestLevel2: TMenuItem;
    Window1: TMenuItem;
    Show1: TMenuItem;
    Hide1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Timer1: TTimer;
    WinTracing1: TWinTracing;
    procedure start1Click(Sender: TObject);
    procedure Restart1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure Line1Click(Sender: TObject);
    procedure Buffer1Click(Sender: TObject);
    procedure Commit1Click(Sender: TObject);
    procedure Conter1Click(Sender: TObject);
    procedure TestErrorClick(Sender: TObject);
    procedure TestLevel1Click(Sender: TObject);
    procedure TestLevel2Click(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure Hide1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    AutoCount: Boolean;
    counter: integer;
  public
    { Public declarations }
  end;

var
  Trace: TTrace;

implementation

uses
  About;

{$R *.DFM}

procedure TTrace.About1Click(Sender: TObject);
begin
   AboutBox := TAboutBox.Create(Self);
   AboutBox.ShowModal;
   AboutBox.Free;
end;

procedure TTrace.start1Click(Sender: TObject);
begin
   WinTracing1.StartTrace;
end;

procedure TTrace.Restart1Click(Sender: TObject);
begin
   WinTracing1.RestartTrace;
end;

procedure TTrace.Stop1Click(Sender: TObject);
begin
   WinTracing1.StopTrace;
end;

procedure TTrace.Commit1Click(Sender: TObject);
begin
   WinTracing1.Trace(0,'%s',['Commit to file']);
   WinTracing1.CommitTrace;
end;

procedure TTrace.Timer1Timer(Sender: TObject);
begin
   if WinTracing1.Active = False then exit;

   if AutoCount then begin
      inc(counter);
      WinTracing1.Trace(1,'Start counter: %d',[counter]);
      end;
   Label5.Caption := IntToStr(WinTracing1.TraceLevel);
   Label6.Caption := WinTracing1.GetFileName;
   Label7.Caption := WinTracing1.GetTraceFileSize;
   Label8.Caption := WinTracing1.GetDiskSpace;
end;

procedure TTrace.Exit1Click(Sender: TObject);
begin
   Close;
end;

procedure TTrace.Line1Click(Sender: TObject);
begin
   WinTracing1.Trace(1,'%s; count: %d',['Line Test Tracing',counter]);
   inc(counter);
end;

procedure TTrace.TestErrorClick(Sender: TObject);
begin
   WinTracing1.Trace(0,'%s',['Error level trace.']);
end;

procedure TTrace.TestLevel1Click(Sender: TObject);
begin
   WinTracing1.Trace(1,'%s',['Level 1 trace.']);
end;

procedure TTrace.TestLevel2Click(Sender: TObject);
begin
   WinTracing1.Trace(2,'%s',['Level 2 trace.']);
end;

procedure TTrace.Conter1Click(Sender: TObject);
begin
  if AutoCount then
      WinTracing1.Trace(1,'Stop counter: %d',[counter])
  else
      WinTracing1.Trace(1,'Start counter: %d',[counter]);
   AutoCount := not AutoCount;
   Conter1.checked := AutoCount;
   SpeedButton10.Down := AutoCount;
end;

procedure TTrace.Show1Click(Sender: TObject);
begin
   WinTracing1.Show;
end;

procedure TTrace.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   WinTracing1.StopTrace;
end;

procedure TTrace.Buffer1Click(Sender: TObject);
var
   buf: array[0..255] of byte;
   i: byte;
begin
   for i := 0 to 255 do
      buf[i] := i;
   WinTracing1.TraceBuffer(1,'Tracing buffer','buf',@buf,0,255,127);
end;

procedure TTrace.Hide1Click(Sender: TObject);
begin
   WinTracing1.Hide;
end;

end.
